from _typeshed import Incomplete
from django.db import models

from .base import PolymorphicModelBase as PolymorphicModelBase
from .managers import PolymorphicManager as PolymorphicManager

class PolymorphicTypeUndefined(LookupError): ...
class PolymorphicTypeInvalid(RuntimeError): ...

class PolymorphicModel(models.Model, metaclass=PolymorphicModelBase):
    polymorphic_model_marker: bool
    polymorphic_query_multiline_output: bool
    polymorphic_ctype: Incomplete
    polymorphic_internal_model_fields: Incomplete
    objects: Incomplete

    class Meta:
        abstract: bool
        base_manager_name: str

    @classmethod
    def translate_polymorphic_Q_object(cls, q): ...
    def pre_save_polymorphic(self, using=...) -> None: ...
    def save(self, *args, **kwargs): ...
    def get_real_instance_class(self): ...
    def get_real_concrete_instance_class_id(self): ...
    def get_real_concrete_instance_class(self): ...
    def get_real_instance(self): ...
    def __init__(self, *args, **kwargs) -> None: ...
